



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入理解javascript作用域系列第一篇</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入理解javascript作用域系列第一篇</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:52:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前面的话</h2>
<p>　　javascript拥有一套设计良好的规则来存储变量，并且之后可以方便地找到这些变量，这套规则被称为作用域。作用域貌似简单，实则复杂，由于作用域与<a href="http://www.cnblogs.com/xiaohuochai/p/5735901.html" rel="external nofollow noreferrer">this机制</a>非常容易混淆，使得理解作用域的原理更为重要。本文是深入理解javascript作用域系列的第一篇&mdash;&mdash;内部原理</p>
<p>　　内部原理分成编译、执行、查询、嵌套和异常五个部分进行介绍，最后以一个实例过程对原理进行完整说明</p>
<h3>编译</h3>
<p>　　以var a = 2;为例，说明javascript的内部编译过程，主要包括以下三步：</p>
<p>【1】分词(tokenizing)</p>
<p>　　把由字符组成的字符串分解成有意义的代码块，这些代码块被称为词法单元(token)</p>
<p>　　var a = 2;被分解成为下面这些词法单元：var、a、=、2、;。这些词法单元组成了一个词法单元流数组</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">// 词法分析后的结果<br />
[<br />
  "var" : "keyword",<br />
  "a" : "identifier",<br />
  "="   : "assignment",<br />
  "2"  : "integer",<br />
  ";"   : "eos" (end of statement)<br />
]</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>【2】解析(parsing)</p>
<p>　　把词法单元流数组转换成一个由元素逐级嵌套所组成的代表程序语法结构的树，这个树被称为&ldquo;抽象语法树&rdquo; (Abstract Syntax Tree, AST)</p>
<p>　　var a = 2;的抽象语法树中有一个叫VariableDeclaration的顶级节点，接下来是一个叫Identifier(它的值是a)的子节点，以及一个叫AssignmentExpression的子节点，且该节点有一个叫Numericliteral(它的值是2)的子节点</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">{<br />
  operation: "=",<br />
  left: {<br />
    keyword: "var",<br />
    right: "a"<br />
  }<br />
  right: "2"<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>【3】代码生成</p>
<p>　　将AST转换为可执行代码的过程被称为代码生成</p>
<p>　　var a=2;的抽象语法树转为一组机器指令，用来创建一个叫作a的变量(包括分配内存等)，并将值2储存在a中</p>
<p>　　实际上，javascript引擎的编译过程要复杂得多，包括大量优化操作，上面的三个步骤是编译过程的基本概述</p>
<p>　　任何代码片段在执行前都要进行编译，大部分情况下编译发生在代码执行前的几微秒。javascript编译器首先会对var a=2;这段程序进行编译，然后做好执行它的准备，并且通常马上就会执行它</p>
<h3>执行</h3>
<p>　　简而言之，编译过程就是编译器把程序分解成词法单元(token)，然后把词法单元解析成语法树(AST)，再把语法树变成机器指令等待执行的过程</p>
<p>　　实际上，代码进行编译，还要执行。下面仍然以var a = 2;为例，深入说明编译和执行过程</p>
<p>【1】编译</p>
<p>　　1、编译器查找作用域是否已经有一个名称为a的变量存在于同一个作用域的集合中。如果是，编译器会忽略该声明，继续进行编译；否则它会要求作用域在当前作用域的集合中声明一个新的变量，并命名为a</p>
<p>　　2、编译器将var a = 2;这个代码片段编译成用于执行的机器指令</p>
<p>　　[注意]依据编译器的编译原理，javascript中的重复声明是合法的</p>
<div>
<pre class="prettyprint linenums">//test在作用域中首次出现，所以声明新变量，并将20赋值给test<br />
var test = 20;<br />
//test在作用域中已经存在，直接使用，将20的赋值替换成30<br />
var test = 30;</pre>
</div>
<p>【2】执行</p>
<p>　　1、引擎运行时会首先查询作用域，在当前的作用域集合中是否存在一个叫作a的变量。如果是，引擎就会使用这个变量；如果否，引擎会继续查找该变量</p>
<p>　　2、如果引擎最终找到了变量a，就会将2赋值给它。否则引擎会抛出一个异常</p>
<h3>查询</h3>
<p>　　在引擎执行的第一步操作中，对变量a进行了查询，这种查询叫做LHS查询。实际上，引擎查询共分为两种：LHS查询和RHS查询</p>
<p>　　从字面意思去理解，当变量出现在赋值操作的左侧时进行LHS查询，出现在右侧时进行RHS查询</p>
<p>　　更准确地讲，RHS查询与简单地查找某个变量的值没什么区别，而LHS查询则是试图找到变量的容器本身，从而可以对其赋值</p>
<div>
<pre class="prettyprint linenums">function foo(a){<br />
    console.log(a);//2<br />
}<br />
foo( 2 );</pre>
</div>
<p>　　这段代码中，总共包括4个查询，分别是：</p>
<p>　　1、foo(...)对foo进行了RHS引用</p>
<p>　　2、函数传参a = 2对a进行了LHS引用</p>
<p>　　3、console.log(...)对console对象进行了RHS引用，并检查其是否有一个log的方法</p>
<p>　　4、console.log(a)对a进行了RHS引用，并把得到的值传给了console.log(...)</p>
<h3>嵌套</h3>
<p>　　在当前作用域中无法找到某个变量时，引擎就会在外层嵌套的作用域中继续查找，直到找到该变量，或抵达最外层的作用域（也就是全局作用域）为止</p>
<div>
<pre class="prettyprint linenums">function foo(a){<br />
    console.log( a + b ) ;<br />
}<br />
var b = 2;<br />
foo(2);// 4</pre>
</div>
<p>　　在代码片段中，作用域foo()函数嵌套在全局作用域中。引擎首先在foo()函数的作用域中查找变量b，并尝试对其进行RHS引用，没有找到；接着，引擎在全局作用域中查找b，成功找到后，对其进行RHS引用，将2赋值给b</p>
<h3>异常</h3>
<p>　　为什么区分LHS和RHS是一件重要的事情？因为在变量还没有声明（在任何作用域中都无法找到变量）的情况下，这两种查询的行为不一样</p>
<p><strong>RHS</strong></p>
<p>【1】如果RHS查询失败，引擎会抛出ReferenceError(引用错误)异常</p>
<div>
<pre class="prettyprint linenums">//对b进行RHS查询时，无法找到该变量。也就是说，这是一个&ldquo;未声明&rdquo;的变量<br />
function foo(a){<br />
    a = b;<br />
}<br />
foo();//ReferenceError: b is not defined</pre>
</div>
<p>【2】如果RHS查询找到了一个变量，但尝试对变量的值进行不合理操作，比如对一个非函数类型值进行函数调用，或者引用null或undefined中的属性，引擎会抛出另外一种类型异常：TypeError(类型错误)异常</p>
<div>
<pre class="prettyprint linenums">function foo(){<br />
    var b = 0;<br />
    b();<br />
}<br />
foo();//TypeError: b is not a function</pre>
</div>
<p><strong>LHS</strong></p>
<p>【1】当引擎执行LHS查询时，如果无法找到变量，全局作用域会创建一个具有该名称的变量，并将其返还给引擎</p>
<div>
<pre class="prettyprint linenums">function foo(){<br />
    a = 1;<br />
}<br />
foo();<br />
console.log(a);//1</pre>
</div>
<p>【2】如果在严格模式中LHS查询失败时，并不会创建并返回一个全局变量，引擎会抛出同RHS查询失败时类似的ReferenceError异常</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function foo(){<br />
    'use strict';<br />
    a = 1;<br />
}<br />
foo();<br />
console.log(a);//ReferenceError: a is not defined</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>原理</h3>
<div>
<pre class="prettyprint linenums">function foo(a){<br />
    console.log(a);<br />
}<br />
foo(2);</pre>
</div>
<p>　　以上面这个代码片段来说明作用域的内部原理，分为以下几步：</p>
<p>【1】引擎需要为foo(...)函数进行RHS引用，在全局作用域中查找foo。成功找到并执行</p>
<p>【2】引擎需要进行foo函数的传参a=2，为a进行LHS引用，在foo函数作用域中查找a。成功找到，并把2赋值给a</p>
<p>【3】引擎需要执行console.log(...)，为console对象进行RHS引用，在foo函数作用域中查找console对象。由于console是个内置对象，被成功找到</p>
<p>【4】引擎在console对象中查找log(...)方法，成功找到</p>
<p>【5】引擎需要执行console.log(a)，对a进行RHS引用，在foo函数作用域中查找a，成功找到并执行</p>
<p>【6】于是，引擎把a的值，也就是2传到console.log(...)中</p>
<p>【7】最终，控制台输出2</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k11vr9.html">Atitit ati&amp;&num;160&semi;licenseService &amp;&num;160&semi;&amp;&num;160&semi;&amp;&num;160&semi;设计原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k1yr79.html">关于TableView上有一段留白的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdzklj9.html">css background-size</a>
		</li>
						<li><a href="https://www.batexi.com/a/390p6148.html">【转】STM32中的抢占优先级、响应优先级概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/495nrjm9.html">为什么relativelayout&period;layoutParams的width为-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq40kyn8.html">js弹出放大图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnk7w6q.html">JQuery ajax请求一直返回Error（parsererror）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydodxdq.html">【Android开发经验】使用Ant批量打包Android应用全然指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z12l139.html">由 OR 引起的死循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnpgd8.html">JAVA内容回顾（二）&mdash;&mdash;面向对象（OOP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zgl3k9.html">【Android Widget】2&period;ImageView</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geg01l8.html">css中的几个小tip（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jvxvl8.html">Redis介绍及Jedis测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzor548.html">【spring源码分析】IOC容器初始化（总结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj422r9.html">python升级后带来的几个小问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkwml9.html">php-编译模块1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwyroj9.html">java----&amp;gt&semi;Itellij idea报错&colon;错误&colon; 找不到或无法加载主类 main</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvdpd2q.html">SOAP port</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmzg6w9.html">Verilog 加法器和减法器&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v7dd5q.html">&lbrack;转&rsqb; Akka 使用系列之二&colon; 测试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnn755kq.html">PHP提取链接批量下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmwpvg9.html">Digging（DP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4prnoeq.html">MongoDB - MongoDB CRUD Operations&comma; Query Documents&comma; Query for Null or Missing Fields</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emnw0e9.html">HOMEWORK-2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkde1x8.html">JS设计模式&mdash;&mdash;2&period;初识接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1gpnk9.html">css 格式中id与class共存</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp0vv79.html">python进阶之内置函数和语法糖触发魔法方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl1xjr9.html">adb&lowbar;usb&period;ini在adb找不到设备时</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve6ov19.html">【BubbleCup X】D&period; Exploration plan</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pr233q.html">github--403错误</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
